<?php
// crypto icons
// http://cryptoicons.co/

// sample and historical data
// coinmarketcap.com

// Binance websocket trade stream API
// https://docs.binance.org/api-reference/dex-api/ws-streams.html
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>phpGrid | Crypto Bot</title>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Inter:wght@100;200;300;400;500;600&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="{{ APP_URL }}/assets/css/app.css" type="text/css" />
</head>
<body>



<ul class="navigation">
  <li><a href="#">Home</a></li>
  <li><a href="#">Market</a></li>
  <li><a href="#">Coins</a></li>
  <li><a href="#">Balance</a></li>
</ul>


<div class="wrapper">
  <header class="header"><h1>Crypto Bot</h1></header>
  <div class="main">

    {{ grid | raw }}

    <button onclick="refreshGrid(phpGrid_CoinMarket);">Reload</button>

  </div>

  <aside class="aside">
    <div>
      <h3>Stock Market Selection</h3>
      <div>
        <select style="width:100%">
          <option value="binance">Binance</option>
          <option value="ftx">FTX</option>
        </select>
      </div>
    </div>
    <div>
      <h3>Coin Selection</h3>
      <div>
        <select id="selectedCoins" style="width:100%" multiple>
          {% for ticker, coin in availCoins %}
            <option value="{{ ticker }}" data-balance="{{ coin['btcValue'] }}">{{ ticker }}</option>
          {% endfor %}
        </select>
      </div>
    </div>
  </aside>

  </aside>
  <footer class="footer">
    <h3>Bot working status</h3>
    <div class="container">
    </div>
  </footer>
</div>



<script src="{{ APP_URL }}/assets/js/app.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-sparklines/2.1.2/jquery.sparkline.min.js" type="text/javascript"></script>

</body>
</html>