<?php
use phpCtrl\C_DataGrid;

const MAX_NOTES = 10;

require_once("../conf.php");
if (!isset($HTTP_POST_VARS) && isset($_POST)){ $HTTP_POST_VARS = $_POST;}  // backward compability when register_long_arrays = off in config

$theme_name = (isset($_POST['_gridThemeRoller']))? $_POST['_gridThemeRoller']:'start';
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>JSON FORM</title>
</head>
<body>

<?php
$json = 
'{
    "data":{
      "id":1,
      "title":null,
      "company_name":"ABC Inc.",
      "name":"Joe Blow",
      "location_name":"Main Office",
      "email":"info@examle.com",
      "cell_phone":"9998881111",
      "alternate_phone":"",
      "billing_street":"3333 Nowhere Circle",
      "billing_city":"Flow Harbor",
      "billing_province":"FL",
      "billing_postcode":"34695",
      "billing_country":"United States",
      "shipping_street":"3330 Nowhere Circle",
      "shipping_city":"Flow Harbor",
      "shipping_province":"FL",
      "shipping_postcode":"34695",
      "shipping_country":"United States",
      "quote_amount":null,
      "quote_type":null,
      "assigned_user_id":null,
      "created_at":"2022-06-15 14:29:59",
      "updated_at":"2022-06-15 14:29:59",
      "notes":[
         {
            "id":1,
            "notable_id":1,
            "subject":"Added new note",
            "notable_type":"App\\\\Models\\\\Lead",
            "posted_type":"App\\\\Models\\\\User",
            "posted_id":2,
            "note":"This is a new note",
            "created_at":"2022-06-27 16:26:25",
            "updated_at":"2022-06-27 16:26:25",
            "created_at_string":"2022-06-27 16:26:25",
            "created_at_diff_string":"2022-06-27 16:26:25",
            "updated_at_string":"2022-06-27 16:26:25"
         },
         {
            "id":2,
            "notable_id":2,
            "subject":"Added new note 2",
            "notable_type":"App\\\\Models\\\\Lead",
            "posted_type":"App\\\\Models\\\\User",
            "posted_id":2,
            "note":"This is a new note 2",
            "created_at":"2022-06-27 16:26:25",
            "updated_at":"2022-06-27 16:26:25",
            "created_at_string":"2022-06-27 16:26:25",
            "created_at_diff_string":"2022-06-27 16:26:25",
            "updated_at_string":"2022-06-27 16:26:25"
         },
         {
            "id":3,
            "notable_id":3,
            "subject":"Added new note 3",
            "notable_type":"App\\\\Models\\\\Lead",
            "posted_type":"App\\\\Models\\\\User",
            "posted_id":2,
            "note":"This is a new note 3",
            "created_at":"2022-06-27 16:26:25",
            "updated_at":"2022-06-27 16:26:25",
            "created_at_string":"2022-06-27 16:26:25",
            "created_at_diff_string":"2022-06-27 16:26:25",
            "updated_at_string":"2022-06-27 16:26:25"
         }
      ]
   }
}';

// prepare data for grid to consume
$data = json_decode($json, true)['data'];
$id = $data['id'];
$notes = $data['notes'];
$noteCnt = count($notes);
unset($data['notes']);

for($i = 0; $i < $noteCnt; $i++){
    $data["note_id_".($i+1)] = $notes[$i]['id'];
    $data["note_subject_".($i+1)] = $notes[$i]['subject'];
    $data["note_note_".($i+1)] = $notes[$i]['note'];
}

$dataArray[] = $data;
//var_dump(dataArray);


$dg = new C_DataGrid($dataArray, "id", "dataArray");

// must use bootstrap theme
$dg->set_theme('bootstrap');

// hide some fields
$dg->set_col_hidden('created_at', false);
$dg->set_col_hidden('updated_at', false);

$dg->enable_resize(false);

// add note header and rename title
for($i = 0; $i < $noteCnt; $i++){
    $cnt = $i+1;

    $dg -> add_form_group_header('note_id_'.$cnt, 'Note #'.$cnt);

    $dg->set_col_title('note_id_'.$cnt, 'ID');
    $dg->set_col_title('note_subject_'.$cnt, 'Subject');
    $dg->set_col_title('note_note_'.$cnt, 'Note');
}


// add custom form button 
$beforeShowForm = <<<BEFORESHOWFORM
function () {
    $('<a href="#" id="btnAddNote">Add Note</a>')
        .click(function() {

            let noteCnt = $('tr[id^="tr_note_note_"]').length;
            let noteCntNext = noteCnt+1;

            // if the node by the next note count exists, we skip to the next until find node doesn't exist
            noteCntNext = getNoteCountNext(noteCntNext);

            let newNote = 
                   `<tr class="FormData"><td class="CaptionTD ui-widget-content" colspan="100%"><div class="form_group_header"><strong>Note #\${noteCntNext}</strong>  <button onClick="removeNote(this, \${noteCntNext})">x</button>  </div></td></tr>

                    <tr class="FormData" id="tr_note_id_\${noteCntNext}"><td class="CaptionTD">ID</td><td class="DataTD"><input type="text" size="30" id="note_id_\${noteCntNext}" name="note_id_\${noteCntNext}" role="textbox" class="FormElement form-control"></td></tr>

                    <tr class="FormData" id="tr_note_subject_\${noteCntNext}"><td class="CaptionTD">Subject</td><td class="DataTD"><input type="text" size="30" id="note_subject_\${noteCntNext}" name="note_subject_\${noteCntNext}" role="textbox" class="FormElement form-control"></td></tr>

                    <tr class="FormData" id="tr_note_note_\${noteCntNext}"><td class="CaptionTD">Note</td><td class="DataTD"><input type="text" size="30" id="note_note_\${noteCntNext}" name="note_note_\${noteCntNext}" role="textbox" class="FormElement form-control"></td></tr>`;

            $('#tr_note_note_' + noteCnt).after(newNote);

            if (noteCntNext === 10) {
                $(this).hide();
            }

        })
        .addClass("fm-button")
        .prependTo("#Act_Buttons>td.EditButton");
}
BEFORESHOWFORM;

$dg->add_event('jqGridAddEditBeforeShowForm', $beforeShowForm);

$dg->enable_edit('FORM', 'U', 'edit_json.php');
$dg->display();
?>


<style>
#gbox_dataArray {
    display: none;
}
.form_group_header {
    border-bottom: 2px solid #aaa;
    padding: 15px 0 0 0;
}
.navButton.navButton-ltr,
.ui-jqdialog-titlebar-close,
#cData {
    display: none;
}
#btnAddNote {
    margin-right: 15px;
}
.vTitle {
    text-orientation: sideways-right; 
    writing-mode: vertical-rl;
    font-size:100px;
    float:right;
}
</style>


<script type="text/javascript">
$(function(){
    let grid = jQuery('#dataArray');

    setTimeout(() => {
        $("#dataArray").jqGrid("setSelection","<?= $id ?>");
        $("#edit_dataArray").click();
    }, 800);

})


function removeNote(el, noteCntNext){
    $('tr[id^=tr_note_id_' + noteCntNext).remove();
    $('tr[id^=tr_note_subject_' + noteCntNext).remove();
    $('tr[id^=tr_note_note_' + noteCntNext).remove();

    el.closest('.FormData').remove();

    $('#btnAddNote').show();
}
    
// get next note that doesn't exist yet
function getNoteCountNext(noteCntNext) {
    console.log(noteCntNext);

    if (document.getElementById('tr_note_note_' + noteCntNext) ) {
        noteCntNext++;
        console.log(noteCntNext);
        return getNoteCountNext(noteCntNext);
    } else {
        return noteCntNext;
    }

}

</script>


<div class="vTitle">
    JSON FORM
</div>

</body>
</html>